<!DOCTYPE html>

<html lang="en" data-content_root="../../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>sagace.core.http_api_client &#8212; sagace 2025 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=5ecbeea2" />
    <link rel="stylesheet" type="text/css" href="../../../_static/basic.css?v=b08954a9" />
    <link rel="stylesheet" type="text/css" href="../../../_static/alabaster.css?v=27fed22d" />
    <script src="../../../_static/documentation_options.js?v=cb975c41"></script>
    <script src="../../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
   
  <link rel="stylesheet" href="../../../_static/custom.css" type="text/css" />
  

  
  

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for sagace.core.http_api_client</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">--------------------------------------------------------------------------------------------------------------------</span>

<span class="sd">Descrição:</span>
<span class="sd">~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~</span>

<span class="sd">Este módulo fornece uma implementação concreta de um cliente HTTP autenticado dentro do sistema SAGACE.</span>
<span class="sd">A classe `HTTPAPIClient` herda de `APIClient`, garantindo que todas as requisições sejam autenticadas e sigam</span>
<span class="sd">um contrato unificado.</span>

<span class="sd">Principais funcionalidades:</span>

<span class="sd">- Realiza requisições HTTP autenticadas (GET, POST, PUT, DELETE).</span>
<span class="sd">- Gerencia o armazenamento e recuperação do token JWT.</span>
<span class="sd">- Lança exceções adequadas em caso de erro na API.</span>

<span class="sd">Classes:</span>

<span class="sd">- ``HTTPAPIClient``: Implementação concreta de `APIClient` utilizando `requests`.</span>

<span class="sd">Exemplo de uso:</span>

<span class="sd">.. code-block:: python</span>

<span class="sd">    from sagace.infrastructure.http_api_client import HTTPAPIClient</span>
<span class="sd">    from sagace.core import TokenStorage</span>

<span class="sd">    api_client = HTTPAPIClient(&quot;https://api.sagace.online&quot;, TokenStorage())</span>
<span class="sd">    response = api_client.get(&quot;/usuario/dados&quot;)</span>
<span class="sd">    print(response)</span>

<span class="sd">Autor: Diego Yosiura</span>
<span class="sd">Última Atualização: 27/02/2025 16:30</span>
<span class="sd">Criado em: 27/02/2025 16:30</span>
<span class="sd">Copyright: (c) Ampere Consultoria Ltda</span>
<span class="sd">Projeto Original: sagace-v2-package</span>
<span class="sd">IDE: PyCharm</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span><span class="w"> </span><span class="nn">requests</span>
<span class="kn">from</span><span class="w"> </span><span class="nn">.</span><span class="w"> </span><span class="kn">import</span> <span class="n">APIClient</span>
<span class="kn">from</span><span class="w"> </span><span class="nn">..exceptions.domain</span><span class="w"> </span><span class="kn">import</span> <span class="n">PermissionDeniedError</span><span class="p">,</span> <span class="n">TokenExpiredError</span><span class="p">,</span> <span class="n">APIRequestError</span>


<div class="viewcode-block" id="HTTPAPIClient">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.http_api_client.HTTPAPIClient">[docs]</a>
<span class="k">class</span><span class="w"> </span><span class="nc">HTTPAPIClient</span><span class="p">(</span><span class="n">APIClient</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Implementação concreta de `APIClient` utilizando `requests`.</span>

<span class="sd">    Esta classe fornece uma implementação real para comunicação com APIs via HTTP,</span>
<span class="sd">    garantindo que todas as requisições sejam autenticadas.</span>

<span class="sd">    Princípios aplicados:</span>
<span class="sd">    - **Liskov Substitution (L - SOLID)**: `HTTPAPIClient` pode ser utilizada no lugar de `APIClient` sem alterar o comportamento esperado.</span>
<span class="sd">    - **Open/Closed (O - SOLID)**: A classe pode ser estendida para novos métodos HTTP sem modificação do código existente.</span>
<span class="sd">    &quot;&quot;&quot;</span>

<div class="viewcode-block" id="HTTPAPIClient.request">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.http_api_client.HTTPAPIClient.request">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">request</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">method</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">endpoint</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Método genérico para requisições HTTP autenticadas.</span>

<span class="sd">        :param method: Método HTTP a ser utilizado (GET, POST, PUT, DELETE).</span>
<span class="sd">        :type method: str</span>
<span class="sd">        :param endpoint: Caminho relativo dentro da API.</span>
<span class="sd">        :type endpoint: str</span>
<span class="sd">        :param kwargs: Parâmetros adicionais para `requests.request()`.</span>
<span class="sd">        :return: Resposta JSON da API.</span>
<span class="sd">        :rtype: dict</span>
<span class="sd">        :raises TokenExpiredError: Se o token estiver expirado.</span>
<span class="sd">        :raises PermissionDeniedError: Se o usuário não tiver permissão para acessar o recurso.</span>
<span class="sd">        :raises APIRequestError: Para quaisquer outros erros da API.</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="c1"># Constrói a URL completa garantindo que não haja barras duplicadas</span>
        <span class="n">url</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">base_url</span><span class="si">}</span><span class="s2">/</span><span class="si">{</span><span class="n">endpoint</span><span class="o">.</span><span class="n">lstrip</span><span class="p">(</span><span class="s1">&#39;/&#39;</span><span class="p">)</span><span class="si">}</span><span class="s2">&quot;</span>
        <span class="n">headers</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_get_headers</span><span class="p">()</span>

        <span class="c1"># Mescla headers passados como argumento com os padrões</span>
        <span class="k">if</span> <span class="s2">&quot;headers&quot;</span> <span class="ow">in</span> <span class="n">kwargs</span><span class="p">:</span>
            <span class="n">kwargs</span><span class="p">[</span><span class="s2">&quot;headers&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">headers</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">kwargs</span><span class="p">[</span><span class="s2">&quot;headers&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">headers</span>

        <span class="c1"># Executa a requisição HTTP</span>
        <span class="n">response</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">request</span><span class="p">(</span><span class="n">method</span><span class="p">,</span> <span class="n">url</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>

        <span class="c1"># Tratamento de erros comuns da API</span>
        <span class="k">if</span> <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">==</span> <span class="mi">401</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">TokenExpiredError</span><span class="p">()</span>
        <span class="k">elif</span> <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">==</span> <span class="mi">403</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">PermissionDeniedError</span><span class="p">()</span>
        <span class="k">elif</span> <span class="ow">not</span> <span class="n">response</span><span class="o">.</span><span class="n">ok</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">APIRequestError</span><span class="p">(</span><span class="n">response</span><span class="o">.</span><span class="n">status_code</span><span class="p">,</span> <span class="n">response</span><span class="o">.</span><span class="n">text</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">response</span><span class="o">.</span><span class="n">json</span><span class="p">()</span></div>


<div class="viewcode-block" id="HTTPAPIClient._get_headers">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.http_api_client.HTTPAPIClient._get_headers">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">_get_headers</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">dict</span><span class="p">:</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Retorna os headers padrão com autenticação JWT.</span>

<span class="sd">        :return: Dicionário de headers HTTP contendo o token JWT.</span>
<span class="sd">        :rtype: dict</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="p">{</span><span class="s2">&quot;Authorization&quot;</span><span class="p">:</span> <span class="sa">f</span><span class="s2">&quot;JWT </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">token_storage</span><span class="o">.</span><span class="n">get_token</span><span class="p">()</span><span class="o">.</span><span class="n">access_token</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">}</span></div>


<div class="viewcode-block" id="HTTPAPIClient.get">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.http_api_client.HTTPAPIClient.get">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">get</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">endpoint</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Método GET autenticado.</span>

<span class="sd">        :param endpoint: Caminho relativo dentro da API.</span>
<span class="sd">        :type endpoint: str</span>
<span class="sd">        :param kwargs: Parâmetros adicionais para a requisição.</span>
<span class="sd">        :return: Resposta JSON da API.</span>
<span class="sd">        :rtype: dict</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">request</span><span class="p">(</span><span class="s2">&quot;GET&quot;</span><span class="p">,</span> <span class="n">endpoint</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span></div>


<div class="viewcode-block" id="HTTPAPIClient.post">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.http_api_client.HTTPAPIClient.post">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">post</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">endpoint</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Método POST autenticado.</span>

<span class="sd">        :param endpoint: Caminho relativo dentro da API.</span>
<span class="sd">        :type endpoint: str</span>
<span class="sd">        :param kwargs: Parâmetros adicionais para a requisição.</span>
<span class="sd">        :return: Resposta JSON da API.</span>
<span class="sd">        :rtype: dict</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">request</span><span class="p">(</span><span class="s2">&quot;POST&quot;</span><span class="p">,</span> <span class="n">endpoint</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span></div>


<div class="viewcode-block" id="HTTPAPIClient.put">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.http_api_client.HTTPAPIClient.put">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">put</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">endpoint</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Método PUT autenticado.</span>

<span class="sd">        :param endpoint: Caminho relativo dentro da API.</span>
<span class="sd">        :type endpoint: str</span>
<span class="sd">        :param kwargs: Parâmetros adicionais para a requisição.</span>
<span class="sd">        :return: Resposta JSON da API.</span>
<span class="sd">        :rtype: dict</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">request</span><span class="p">(</span><span class="s2">&quot;PUT&quot;</span><span class="p">,</span> <span class="n">endpoint</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span></div>


<div class="viewcode-block" id="HTTPAPIClient.delete">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.http_api_client.HTTPAPIClient.delete">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">delete</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">endpoint</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Método DELETE autenticado.</span>

<span class="sd">        :param endpoint: Caminho relativo dentro da API.</span>
<span class="sd">        :type endpoint: str</span>
<span class="sd">        :param kwargs: Parâmetros adicionais para a requisição.</span>
<span class="sd">        :return: Resposta JSON da API.</span>
<span class="sd">        :rtype: dict</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">request</span><span class="p">(</span><span class="s2">&quot;DELETE&quot;</span><span class="p">,</span> <span class="n">endpoint</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span></div>
</div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="Main">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../index.html">sagace</a></h1>









<search id="searchbox" style="display: none" role="search">
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" placeholder="Search"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</search>
<script>document.getElementById('searchbox').style.display = "block"</script><h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Conteúdo:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../modules.html">sagace</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../index.html">Documentation overview</a><ul>
  <li><a href="../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &#169;2025, Ampere Consultoria.
      
      |
      Powered by <a href="https://www.sphinx-doc.org/">Sphinx 8.2.1</a>
      &amp; <a href="https://alabaster.readthedocs.io">Alabaster 1.0.0</a>
      
    </div>

    

    
  </body>
</html>